package sim;

import java.io.*;

import org.eclipse.swt.widgets.*;
import sim.GuiEngineLink;
import sim.engine.*;

import java.util.ArrayList;
import java.util.List;

public class VHDLExporter {
	
	public void Export() throws IOException {
		VHDLExportChoices simDialog = new VHDLExportChoices();
		simDialog.setVisible(true);
		Display display = new Display();
		Shell shell = new Shell(display);
		//shell.open();
		DirectoryDialog dialog = new DirectoryDialog(shell);
		String path = dialog.open();
		shell.close();
		while (!shell.isDisposed()) {
	        if (!display.readAndDispatch())
	            display.sleep();
	    }
	    display.dispose();
		
		Writer writer = null;
		Writer writertb = null;
		try {
			writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(path+"\\main.vhd")));
			writer.write("library IEEE;\n");
			writer.write("use IEEE.STD_LOGIC_1164.ALL;\n\n");
			writertb = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(path+"\\testbench.vhd")));
			writertb.write("library IEEE;\n");
			writertb.write("use IEEE.STD_LOGIC_1164.ALL;\n");
			writertb.write("use ieee.std_logic_unsigned.all;\n");
			writertb.write("use ieee.numeric_std.all;\n");
			Writer writer_temp = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(path+"\\gates.vhd")));
			writer_temp.write("");
			writer_temp.close();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		GuiEngineLink link = new GuiEngineLink();
		SimulationEngine se = link.createPeer();
		EnginePeerList epl = se.getComponents();
		
		for (Object o : epl){
			EnginePeer ep = (EnginePeer)o;
			/*switch(ep.getParent().getClass().getName()) {
				case "sim.lib.gates.GateAND":
					writer.write("GateAND\n");
			}*/
			ep.getParent().writeVHDLEntity(path); //write the component entities
			
			//TODO setup connections
			//ep.getInputPins();
			//ep.getOutputPins();
			
		}
		
		int wires = CentralPanel.ACTIVE_GRID.getNumberOfWires();

		writer.write("entity main is\n");
		writertb.write("entity testbench is\n");
		writertb.write("end testbench;\n");
		writertb.write("architecture Behavioral of testbench is\n");
		writertb.write("component main\n");
		writertb.write("port(\n");
		//write input/output ports for circuit (new component?)
		int flag = 0;
		List<Integer> ids = new ArrayList<Integer>();
		List<Integer> idsforio = new ArrayList<Integer>();
		List<Integer> idsforoutput = new ArrayList<Integer>();
		List<Integer> ioids = new ArrayList<Integer>();
		List<Integer> clockids = new ArrayList<Integer>();
		List<Integer> buttonids = new ArrayList<Integer>();
		List<Integer> constantids = new ArrayList<Integer>();
		List<EnginePeer> clockeps = new ArrayList<EnginePeer>();
		List<EnginePeer> buttoneps = new ArrayList<EnginePeer>();
		List<EnginePeer> constanteps = new ArrayList<EnginePeer>();
		List<EnginePeer> busconstanteps = new ArrayList<EnginePeer>();
		if (wires >= 0){
			//writer.write("	signal temp0");
			int id = 0;
			int size = 1;
			boolean found = false;
			for (Object o : epl){
				EnginePeer ep = (EnginePeer)o;
				for(int i = 0; i < ep.getInputPins().getSize();i++){
					found = false;
					id = ep.getInputPins().getItemAt(i).getConnection().getId();
					for (int h : idsforio){
							if(h == id)
								found = true;
					}
					if (!found){
						size = ep.getInputPins().getItemAt(i).getConnection().getSize();
						idsforio.add(id);
					}
				}
				if(ep.getOutputPins() != null){
					for(int i = 0; i < ep.getOutputPins().getSize();i++){
						found = false;
						ep.getOutputPins().getItemAt(i).getConnection().getSize(); //size of wire
						id = ep.getOutputPins().getItemAt(i).getConnection().getId();
						for (int h : idsforio){
								if(h == id)
									found = true;
						}
						if (!found){
							idsforio.add(id);
						}
					}
				}
			}
		}
		int newid = 0;
		for (Object o : epl) {
			EnginePeer ep = (EnginePeer)o;
			String Name = ep.getParent().getVHDLName();
			int id = 0;
			int inputSize = 0;
			int size = 1;
			boolean found = false;
			if(Name == "Button" || Name == "Clock" || Name.contains("CONSTANT") || Name.contains("BusConstant")) {
				if(Name.contains("BusConstant"))
					busconstanteps.add(ep);
				else {
					if(flag == 0) {
						writer.write("port(");
						flag = 1;
					}
					id = ep.getOutputPins().getItemAt(0).getConnection().getId();
					for(;;newid ++) {
						found = false;
						for (int h : idsforio){
								if(h == newid)
									found = true;
						}
						if (!found){
							size = ep.getOutputPins().getItemAt(0).getConnection().getSize();
							idsforio.add(newid);
							idsforoutput.add(newid);
							idsforoutput.add(id);
							if(Name == "Clock")
								idsforoutput.add(2);
							else if(Name == "Button")
								idsforoutput.add(3);
							else if(Name.contains("CONSTANT"))
								idsforoutput.add(4);
							break;
						}
					}
					if(flag == 1) {
						id = ep.getOutputPins().getItemAt(0).getConnection().getId();
						writer.write("--" + Name);
						writertb.write("--" + Name);
						if(Name == "Clock") {
							writer.write(":\ntemp" + newid + " : in std_logic");
							writertb.write(":\ntemp" + newid + " : in std_logic");
							ioids.add(newid);
							ioids.add(1);
							clockids.add(newid);
							clockeps.add(ep);
						} else if(Name =="Button") {
							writer.write(":\ntemp" + newid + " : in std_logic");
							writertb.write(":\ntemp" + newid + " : in std_logic");
							ioids.add(newid);
							ioids.add(-1);
							buttonids.add(newid);
							buttoneps.add(ep);
						} else if(Name.contains("CONSTANT")){
							writer.write(":\ntemp" + newid + " : in std_logic");
							writertb.write(":\ntemp" + newid + " : in std_logic");
							ioids.add(newid);
							ioids.add(2);
							constantids.add(newid);
							constanteps.add(ep);
						}
						flag = 2;
					} else {
						found = false;
						id = ep.getOutputPins().getItemAt(0).getConnection().getId();
						for (int h : ids){
								if(h == id)
									found = true;
						}
						if (!found){
							size = ep.getOutputPins().getItemAt(0).getConnection().getSize();
							if(Name == "Clock") {
								writer.write(";\n--" + Name + ":\ntemp" + newid + " : in std_logic");
								writertb.write(";\n--" + Name + ":\ntemp" + newid + " : in std_logic");
								ioids.add(newid);
								ioids.add(1);
								clockids.add(newid);
								clockeps.add(ep);
							} else if(Name =="Button") {
								writer.write(";\n--" + Name + ":\ntemp" + newid + " : in std_logic");
								writertb.write(";\n--" + Name + ":\ntemp" + newid + " : in std_logic");
								ioids.add(newid);
								ioids.add(-1);
								buttonids.add(newid);
								buttoneps.add(ep);
							} else if(Name.contains("CONSTANT")){
								writer.write(";\n--" + Name + ":\ntemp" + newid + " : in std_logic");
								writertb.write(";\n--" + Name + ":\ntemp" + newid + " : in std_logic");
								ioids.add(newid);
								ioids.add(2);
								constantids.add(newid);
								constanteps.add(ep);
							}
						}
					}
				}
			}
			else if(Name == "Led" || Name == "LCD" || Name == "NumberDisplay") {
				if(flag == 0) {
					writer.write("port(\n");
					flag = 1;
				}
				if(Name == "Led") {
					id = ep.getInputPins().getItemAt(0).getConnection().getId();
					for(;;newid ++) {
						found = false;
						for (int h : idsforio){
								if(h == newid)
									found = true;
						}
						if (!found){
							size = ep.getInputPins().getItemAt(0).getConnection().getSize();
							idsforio.add(newid);
							idsforoutput.add(newid);
							idsforoutput.add(id);
							idsforoutput.add(5);
							ioids.add(newid);
							ioids.add(0);
							break;
						}
					}
					if(flag == 1) {
						writer.write("--" + Name);
						writertb.write("--" + Name);
						writer.write(":\ntemp" + newid + " : out std_logic");
						writertb.write(":\ntemp" + newid + " : out std_logic");
						flag = 2;
					} else {
						writer.write(";\n--" + Name + ":\ntemp" + newid + " : out std_logic");
						writertb.write(";\n--" + Name + ":\ntemp" + newid + " : out std_logic");
					}
				} else {
					inputSize = ep.getInputPins().getSize();
					if(flag == 1) {
						id = ep.getInputPins().getItemAt(0).getConnection().getId();
						for(;;newid ++) {
							found = false;
							for (int h : idsforio){
									if(h == newid)
										found = true;
							}
							if (!found){
								size = ep.getInputPins().getItemAt(0).getConnection().getSize();
								idsforio.add(newid);
								idsforoutput.add(newid);
								idsforoutput.add(id);
								if(Name == "NumberDisplay")
									idsforoutput.add(6);
								else
									idsforoutput.add(7);
								ioids.add(newid);
								ioids.add(0);
								break;
							}
						}
						writer.write("--" + Name);
						writertb.write("--" + Name);
						writer.write(":\ntemp" + newid + " : out std_logic");
						writertb.write(":\ntemp" + newid + " : out std_logic");
						for(int i = 1; i < inputSize;i++){
							found = false;
							id = ep.getInputPins().getItemAt(i).getConnection().getId();
							for(;;newid ++) {
								found = false;
								for (int h : idsforio){
										if(h == newid)
											found = true;
								}
								if (!found){
									size = ep.getInputPins().getItemAt(i).getConnection().getSize();
									idsforio.add(newid);
									idsforoutput.add(newid);
									idsforoutput.add(id);
									if(Name == "NumberDisplay")
										idsforoutput.add(6);
									else
										idsforoutput.add(7);
									ioids.add(newid);
									ioids.add(0);
									break;
								}
							}
							writer.write(";\ntemp" + newid + " : out std_logic");
							writertb.write(";\ntemp" + newid + " : out std_logic");
						}
						flag = 2;
					} else {
						id = ep.getInputPins().getItemAt(0).getConnection().getId();
						for(;;newid ++) {
							found = false;
							for (int h : idsforio){
									if(h == newid)
										found = true;
							}
							if (!found){
								size = ep.getInputPins().getItemAt(0).getConnection().getSize();
								idsforio.add(newid);
								idsforoutput.add(newid);
								idsforoutput.add(id);
								if(Name == "NumberDisplay")
									idsforoutput.add(6);
								else
									idsforoutput.add(7);
								ioids.add(newid);
								ioids.add(0);
								break;
							}
						}
						writer.write(";\n--" + Name + ":\ntemp" + newid + " : out std_logic");
						writertb.write(";\n--" + Name + ":\ntemp" + newid + " : out std_logic");
						for(int i = 1; i < inputSize;i++){
							id = ep.getInputPins().getItemAt(i).getConnection().getId();
							for(;;newid ++) {
								found = false;
								for (int h : idsforio){
										if(h == newid)
											found = true;
								}
								if (!found){
									size = ep.getInputPins().getItemAt(0).getConnection().getSize();
									idsforio.add(newid);
									idsforoutput.add(newid);
									idsforoutput.add(id);
									if(Name == "NumberDisplay")
										idsforoutput.add(6);
									else
										idsforoutput.add(7);
									ioids.add(newid);
									ioids.add(0);
									break;
								}
							}
							writer.write(";\ntemp" + newid + " : out std_logic");
							writertb.write(";\ntemp" + newid + " : out std_logic");
						}
					}
				}
			//writer.write(");\n");
			}
		}
		writer.write(");\n");
		writertb.write(");\n");
		writer.write("end main;\n\n");
		writertb.write("end component;\n\n");
		
		for(int i = 0, k = 0, t = 0; i < ioids.size() / 2; i ++) {
			int j = 0;
			writertb.write("signal temp" + ioids.get(2 * i) + " : std_logic");
			j = ioids.get(2 * i + 1);
			if(j == 2) {
				writertb.close();
				constanteps.get(k).getParent().writeVHDLEntity(path);
				writertb = new FileWriter(path+"\\testbench.vhd",true);
				k ++;
			} else if(j == -1) {
				writertb.close();
				buttoneps.get(t).getParent().writeVHDLEntity(path);
				writertb = new FileWriter(path+"\\testbench.vhd",true);
				t ++;
			} else if(j != 0) {
				writertb.write(" := '0';\n");
			} else
				writertb.write(";\n");
		}
		
		for(int i = 0; i < clockids.size(); i ++) {
			int j = 1;
			if(j > 0)
				writertb.write("constant clk_period" + i);
				writertb.close();
				clockeps.get(i).getParent().writeVHDLEntity(path);
				writertb = new FileWriter(path+"\\testbench.vhd",true);
		}
		writertb.write("begin\n");
		writertb.write("comp:main port map(");
		for(int i = 0; i < ioids.size() / 2; i ++) {
			writertb.write("temp" + ioids.get(2 * i));
			if(i + 1 != ioids.size() / 2)
				writertb.write(", ");
		}
		writertb.write(");\n");
		for(int i = 0; i < clockids.size(); i ++) {
			writertb.write("clk_gen" + i + ":process\n");
			writertb.write("begin\n");
			writertb.write("wait for clk_period" + i + " / 2;\n");
			writertb.write("temp" + clockids.get(i) + "<= '1';\n");
			writertb.write("wait for clk_period" + i + " / 2;\n");
			writertb.write("temp" + clockids.get(i) + "<= '0';\n");
			writertb.write("end process;\n");
		}
		for(int i = 0; i < buttonids.size(); i ++) {
			writertb.write("button_gen" + i + ":process\n");
			writertb.write("begin\n");
			writertb.write("wait for " + (i + 1) * 20 + "ns;\n");
			writertb.write("temp" + buttonids.get(i) + "<= not temp" + buttonids.get(i) + ";\n");
			writertb.write("wait for " + 40 + "ns;\n");
			writertb.write("temp" + buttonids.get(i) + "<= not temp" + buttonids.get(i) + ";\n");
			writertb.write("end process;\n");
		}
		writertb.write("end Behavioral;");
		writertb.close();
		writer.write("architecture struct of main is\n");
		//write signals(wires/buses)
		if (wires >= 0){
			//writer.write("	signal temp0");
			int id = 0;
			int size = 1;
			boolean found = false;
			for (Object o : epl){
				EnginePeer ep = (EnginePeer)o;
				for(int i = 0; i < ep.getInputPins().getSize();i++){
					found = false;
					//hash = ep.getInputPins().getItemAt(i).getConnection().hashCode();
					id = ep.getInputPins().getItemAt(i).getConnection().getId();
					for (int h : ids){
							if(h == id)
								found = true;
					}
					if (!found){
						size = ep.getInputPins().getItemAt(i).getConnection().getSize();
						//if (size == 1) { //size of wire
							writer.write("signal temp"+id+": std_logic;\n");
							ids.add(id);							
						/*}else{
							writer.write("signal temp"+id+": std_logic_vector("+(size-1)+" downto 0);\n");
						}(*/
					}
				}
				if(ep.getOutputPins() != null){
					for(int i = 0; i < ep.getOutputPins().getSize();i++){
						found = false;
						ep.getOutputPins().getItemAt(i).getConnection().getSize(); //size of wire
						//hash = ep.getOutputPins().getItemAt(i).getConnection().hashCode();
						id = ep.getOutputPins().getItemAt(i).getConnection().getId();
						for (int h : ids){
								if(h == id)
									found = true;
						}
						if (!found){
							//if (ep.getInputPins().getItemAt(i).getConnection().getSize() == 1) { //size of wire
								writer.write("signal temp"+id+": std_logic;\n");
								ids.add(id);							
							/*}else{
								writer.write("signal temp"+id+": std_logic_vector("+(size-1)+" downto 0);\n");
							}*/
						}
					}
				}
			}
			//writer.write(": std_logic;"); //TODO extend to vectors etc.
		}
		writer.write("\nbegin\n");
		//writer join all components
		for(int i = 0; i < busconstanteps.size(); i++) {
			writer.close();
			busconstanteps.get(i).getParent().writeVHDLEntity(path);
			writer = new FileWriter(path+"\\main.vhd",true);
		}
		int id = 0;
		int inputSize = 0;
		for (Object o : epl){
			EnginePeer ep = (EnginePeer)o;
			String Name = ep.getParent().getVHDLName();
			if(!Name.contains("CONSTANT") && Name != "Button" && Name != "Clock" && Name != "Led" && Name != "LCD" && Name != "NumberDisplay" && !Name.contains("BusConstant")) {
				writer.write("	comp_" + id + " : entity work.");
				id++;
				writer.write(ep.getParent().getVHDLName()+ " port map (");
				inputSize = ep.getInputPins().getSize();
				if(ep.getParent() instanceof sim.lib.memory.Ram){
					for(int i = 0; i < 3;i++){
						ep.getInputPins().getItemAt(i).getConnection().getSize(); //size of wire
						writer.write("temp"+ep.getInputPins().getItemAt(i).getConnection().getId()+ ",");
					}
					//inputSize = inputSize - ((sim.lib.memory.Ram)ep.getParent()).getBusSize();
					for(int i = 3+((sim.lib.memory.Ram)ep.getParent()).getBusSize(); i < ep.getInputPins().getSize();i++){
						ep.getInputPins().getItemAt(i).getConnection().getSize(); //size of wire
						writer.write("temp"+ep.getInputPins().getItemAt(i).getConnection().getId()+ ",");
					}
				}else{
					for(int i = 0; i < inputSize;i++){
						ep.getInputPins().getItemAt(i).getConnection().getSize(); //size of wire
						writer.write("temp"+ep.getInputPins().getItemAt(i).getConnection().getId()+ ",");
					}
				}
				if (ep.getOutputPins() != null){
					for(int i = 0; i < ep.getOutputPins().getSize()-1;i++){
						ep.getOutputPins().getItemAt(i).getConnection().getSize(); //size of wire
						writer.write("temp"+ep.getOutputPins().getItemAt(i).getConnection().getId()+","); //add , here..
					}
					writer.write("temp"+ep.getOutputPins().getItemAt(ep.getOutputPins().getSize()-1).getConnection().getId()+");\n");
				}
				else{
					writer.write(");\n");
				}
			}
			//writer.write(");\n");
		}
		for(int i = 0; i < idsforoutput.size() / 3; i++) {
			int j;
			j = idsforoutput.get(3 * i + 2);
			if(j == 2) {
				writer.write("	process (temp" + idsforoutput.get(3 * i) + ") is\n");
				writer.write("	variable count: integer := 0;\n");
				writer.write("	begin\n");
				writer.write("	if rising_edge(temp" + idsforoutput.get(3 * i) + ") then");
				writer.write("	count := count + 1;\n");
				writer.write("	if count = " + (int)(sim.VHDLExportChoices.FROM / sim.VHDLExportChoices.TO / 2) + " then\n");
				writer.write("	temp" + idsforoutput.get(3 * i + 1) + " <= '1';\n");
				writer.write("	elsif count = " + (int)(sim.VHDLExportChoices.FROM / sim.VHDLExportChoices.TO - 1) + " then\n");
				writer.write("	count := 0;\n");
				writer.write("	temp" + idsforoutput.get(3 * i + 1) + " <= '0';\n");
				writer.write("	end if;\n");
				writer.write("	end if;\n");
				writer.write("	end process;\n");
			}
			else if(j == 5||j == 6||j == 7) {
				writer.write("	temp" + idsforoutput.get(3 * i) + " <= ");
				if((j == 5 && !(VHDLExportChoices.LED_COLOR == SimulationProperties.ONE_COLOR)) || (j == 6 && !(VHDLExportChoices.ND_COLOR == SimulationProperties.ONE_COLOR)))
					writer.write("not ");
				writer.write("temp" + idsforoutput.get(3 * i + 1) + ";\n");
			}
			else if(j == 3||j == 4) {
				writer.write("	temp" + idsforoutput.get(3 * i + 1) + " <= ");
				if((j == 3 && !(VHDLExportChoices.PB_COLOR == SimulationProperties.ONE_COLOR)) || (j == 4 && !(VHDLExportChoices.SW_COLOR == SimulationProperties.ONE_COLOR)))
					writer.write("not ");
				writer.write("temp" + idsforoutput.get(3 * i) + ";\n");
			}
		}
		writer.write("end struct;");
		
		writer.close();
	}
	
	public static void writeLib(String path){
		try{
			FileWriter gwriter = new FileWriter(path+"\\gates.vhd",true);
			gwriter.write("\nlibrary IEEE;\n");
			gwriter.write("use IEEE.STD_LOGIC_1164.ALL;\n");
			gwriter.close();
		} catch (Exception e){
			
		}
	}
}
