package sim.util;

import java.awt.*;
import java.awt.event.*;

public class StickyLightButtonListenerForButton extends MouseAdapter implements MouseMotionListener
{
    private boolean buttonUpOnLastMouseDown = true;
	
	public void activate(LightButton lb)
	{
		lb.setArmed(false);
		lb.processActionEvent();
	}
	
	public void arm(LightButton lb)
	{
		lb.setArmed(true);
	}
	
	public void disarm(LightButton lb)
	{ 
		lb.setArmed(false);
	}
	
    public void mousePressed(MouseEvent event)
	{
		LightButton lb = (LightButton)event.getSource();
		if(lb.isEnabled())
		{
        	if(lb.isRaised())
				lb.setInset();
        	else
				lb.setRaised();
			
        	this.buttonUpOnLastMouseDown = lb.isRaised();
			this.arm(lb);
		}
		this.activate(lb);
    }
	
	public void mouseClicked(MouseEvent event)
	{
	}
	
	public void mouseReleased(MouseEvent event)
	{
		LightButton lb = (LightButton)event.getSource();
		if(lb.isEnabled())
		{
        	if(lb.isRaised()) 
				lb.setInset();
        	else
				lb.setRaised();
			
        	this.buttonUpOnLastMouseDown = lb.isRaised();
			this.arm(lb);
		}
		this.activate(lb);
	}
	
    public void mouseDragged(MouseEvent event)
	{
		SimButton ib = (SimButton) event.getSource();
		if (ib.isEnabled() && ib.isArmed()) {
			Point loc = event.getPoint();

			if (ib.contains(loc.x, loc.y)) {
				if (this.buttonUpOnLastMouseDown) {
					if (!ib.isRaised()) {
						ib.paintRaised();
					}
				} else if (ib.isRaised()) {
					ib.paintInset();
				}
			} else {
				if (this.buttonUpOnLastMouseDown) {
					if (ib.isRaised()) {
						ib.paintInset();
					}
				} else if (!ib.isRaised()) {
					ib.paintRaised();
				}
			}
		}
	}
	
	public void mouseMoved(MouseEvent event)
	{
	}
}